/*
 * Copyright (c) 1988, Julian Onions. 
 *
 * This source may be freely distributed, however I would be interested
 * in any changes that are made.
 */

/*
 * $Header: if_tnreg.h,v 1.6 88/07/11 08:28:48 jpo Exp $
 *
 * $Log:	if_tnreg.h,v $
 * Revision 1.6  88/07/11  08:28:48  jpo
 * Some tidying up
 * 
 * Revision 1.5  87/11/04  14:14:29  jpo
 * Update a few flags etc.
 * 
 * Revision 1.4  87/10/19  08:35:09  jpo
 * General clean up - plus sun specific fixes
 * 
 * Revision 1.3  87/10/16  17:09:10  jpo
 * Purged the ad-hoc routing stuff. Added select too.
 * 
 * Revision 1.2  87/10/04  18:30:05  jpo
 * Added select & r/w
 * 
 *
 */
/*
 * defines for the Tunnel pseudo driver.
 */

/* #define TUNMTU	576	/* maximum size packet sent to iface */
#define TUNMTU		1500	/* maximum size packet sent to iface */

#define TUN_INITED      0x001	/* device has been initialised */
#define TUN_RWAIT       0x002	/* waiting for a read from the i/f */
#define TUN_OPEN        0x004	/* device is open */
#define TUN_IASET	0x008	/* interface address set */
#define	TUN_DSTADDR	0x010	/* destination address set */
#define TUN_READY	(TUN_IASET|TUN_OPEN|TUN_DSTADDR)
				/* device ready for use */
#define TUN_WCOLL	0x020	/* select write collision (not supported) */
#define TUN_RCOLL	0x040	/* select collision on read */
#define TUN_NBIO	0x080	/* non block I/O state */
#define TUN_ASYNC	0x100	/* async I/O state */
/*
 * ioctl calls for the special device.
 */
#define TUNSDEBUG       _IOW(u, 0, int) /* set debugging level on/off */
#define TUNGDEBUG	_IOR(u, 1, int) /* read debugging level */
